// ginterval.cc -- generick tda Interval

#include <iostream>
#include <cstdlib>
using namespace std;

void error(char *s)  // funkce pro hlen chyb
{
  cerr << "Error: " << s << endl;
  exit(1);
}

class Number {       // bzov tda
};

class Integer : Number {          // tda celch sel
  int n;  // hodnota sla
 public:
  Integer(int i=0) { n=i; }                      // inicializace
  int SetValue(int i) { return n=i; }            // nastaven hodnoty
  int operator = (int i) { return SetValue(i); }
  int GetValue() { return n; }                   // zskn hodnoty
  operator int () { return GetValue(); }
};

template<int min, int max>
class Interval : public Integer { // tda interval z celch sel
  void RangeCheck( int i ) {                // test rozsahu
    if (i<min || i>max) error("Range check");
  }
 public:
  Interval(int init=min) {  // konstruktor a inicializace
    if(min>=max) error("Bad interval");
    SetValue(init);
  }
  int Min() { return min; }                 // zskn mez
  int Max() { return max; }
  int SetValue(int i) {                     // nastaven hodnoty
    RangeCheck(i);
    return Integer::SetValue(i);            // voln zddn metody
  }
  int operator = (int i) {
    return SetValue(i);
  }
};

class Point {
  Interval<0,100> x;  // lokln objekty - souadnice
  Interval<0,100> y;
 public:
  Point(int _x, int _y) : x(_x), y(_y) {} // voln konstruktor
  int X() { return x; }
  int Y() { return y; }
};


int main()  // testovn ...
{
  Point a(10,20);
  Point b(30,40);
  Interval<0,80> i;
  Interval<0,100> j=70;
  Interval<0,100> k(j);               // implicitn copy konstruktor
  k = i = j;
  int v = i - 50;
  k = v;
  cout << "i = "   << i.GetValue() << endl;  
  cout << "k = "   << int(k)       << endl;        
  cout << "b.x = " << b.X()        << endl;
  return 0;
}
