// nestclas.cc -- vnoen tdy

#include <iostream>
using namespace std;

class Object {                  // abstraktn tda
 public:
  virtual void Print() const = 0; // tisk objektu 
};

// seznam -- Pozor: nee se ruen objekt
class List {                    // tda definujc obecn seznam
  class ListItem {              // vnoen tda -- prvek seznamu
    Object *objptr;             // odkaz na objekt
    ListItem *next;             // ukazatel na dal prvek
   public:
    ListItem(Object *o, ListItem *n=0);
    Object *Obj() const    { return objptr; }
    ListItem *Next() const { return next; }
    void Print() const     { objptr->Print(); }
  };
  ListItem *first;              // prvn prvek seznamu
 public:
  List() { first=0; }           // inicializace -- przdn seznam
  void Insert(Object *);        // vloen prvku
  void *First() const;          // prvn prvek
  void Print() const;           // tisk seznamu
  // ...
};

// konstruktor vnoen tdy List::ListItem
List::ListItem::ListItem(Object *o, List::ListItem *n) {
  objptr=o;
  next=n;
}

void List::Insert(Object *p) {  // vloit na prvn msto
  ListItem *x = new ListItem(p,first);
  first = x;
}

void List::Print() const {            // tisk seznamu
  ListItem *p = first;
  for(p=first; p; p=p->Next())
    p->Print();
}

void *List::First() const {
  if(first) return first->Obj();
  else      return 0;
}

// tdy pro vkldan objekty
class Integer : public Object {
  int i;
 public:
  Integer(int x=0) : i(x) {}
  void Print() const { cout << i << '\n'; }
};

class String : public Object {
  const char *s;
 public:
  String(const char *x="") : s(x) {}
  void Print() const { cout << s << '\n'; }
};


int main() {  // test
  List list;  // vytvo seznam
  list.Insert(new Integer(10));
  list.Insert(new Integer(20));
  list.Insert(new Integer(30));
  list.Insert(new String("text1"));
  list.Insert(new String("text2"));

  list.Print();                 // tisk prvk seznamu

  return 0;
}
