// stl-list.cc
//
// demonstrace pouit kontejneru list ze standardn knihovny C++ (STL)
//

#include <list>       // list
#include <algorithm>  // copy()
#include <numeric>    // accumulate()
#include <iostream>
using namespace std;

int main() {
   const int SIZE = 5;
   int a[SIZE] = {  1, 2, 3, 4, 5  };

   list<int> l;              // przdn seznam
   list<double> l2(3, 3.14); // obsahuje 3 stejn hodnoty

   // naplnn seznamu algoritmem copy z pole a
   copy( a, a+SIZE, inserter(l,l.begin()) );
   //               ^^^^^^^^^^^^^^^^^^ vlo sekvenci na zatek seznamu 
  
   // tisk seznamu cyklem
   cout << "list<double> : ";
   for(list<double>::const_iterator i=l2.begin(); i!=l2.end(); i++)
      cout << *i << " " ;
   cout << endl;

   // tisk seznamu algoritmem copy
   cout << "list<int>    : ";
   ostream_iterator<int> output(cout," "); // vstupn itertor
   copy(l.begin(), l.end(), output);       // kopie na vstup
   cout << endl;
   
   // algoritmus accumulate nad seznamem
   cout << "list<int> sum: " << accumulate(l.begin(),l.end(), 0) << endl;

   return 0;
}

