// stl-sort.cc
//
// pklad pouit algoritmu sort ze standardn knihovny C++
//

#include <vector>      // vector
#include <algorithm>   // sort, copy
#include <functional>  // greater
#include <iostream>    // <iostream.h> pro GCC 2.7.2
#include <iterator>

using namespace std;

// tisk vektoru
void tisk(vector<int>& v) {
  ostream_iterator<int> output(cout, " "); // vstupn itertor      
  cout << "vector: ";
  copy(v.begin(), v.end(), output);        // kopie vektoru na vstup
  cout << endl;
}

int main() {
  const int SIZE = 5;
  static int a[SIZE] = { 4, 2, 5, 1, 3 };
  
  vector<int> v(SIZE);           // vektor s poten velikost SIZE
  
  copy(a, a+SIZE, v.begin() );   // naplnme vektor z pole (itertor
                                 // pro obyejn pole je ukazatel)
  tisk(v);

  cout << "sort> ";              // aplikujeme algoritmus sort
  sort(v.begin(), v.end(), greater<int>() ); // azen sestupn
  //     od        do      funkn objekt pro porovnn
  tisk(v);

  cout << "sort< ";              // aplikujeme algoritmus sort
  sort(v.begin(), v.end());      // azen vzestupn
  tisk(v);
  
  return 0;
}

