// dtr3.cc -- virtuln destruktory 
//
// tda List ru destruktorem vechny objekty v seznamu
// List je polymorfn a vyaduje virtuln destruktory u prvk seznamu

#include <iostream>
using namespace std;

class List;                      // nepln deklarace seznamu

class Base {                     // bzov tda prvk seznamu
  friend class List;
  Base *Next;
 public:
  virtual void Print() const =0; // virtuln metoda
  virtual ~Base() {};            // nesm bt ist virtuln = 0
};

class Type1 : public Base {      // prvek seznamu, typ 1
  int i;
 public:
  Type1(int x) : i(x)  { cout << " Type1(" << i << ")\n"; }
  void Print() const   { cout << i ; }
  ~Type1()             { cout << " ~Type1() " << i << "\n"; }
};

class Type2 : public Base {     // prvek seznamu, typ 2
  char c;
 public:
  Type2(char x) : c(x) { cout << " Type2('" << c << "')\n"; }
  void Print() const   { cout << c ; }
  ~Type2()             { cout << " ~Type2() '" << c << "'\n"; }
};

class List {                    // seznam
  Base *first;
 public:
  List();
  ~List();
  int Empty() const { return first==0; }
  void Print() const;
  void Insert(Base *x);
  void DeleteFirst();
};

List::List() : first(0) {
  cout << "\n\nList()\n";
}

List::~List() {
  cout << "\n~List()\n";
  while(!Empty())
    DeleteFirst();  // seznam je vlastnkem obsahu
}

void List::Insert(Base *x) {
  x->Next = first;
  first = x;
}

void List::DeleteFirst() {
  if(Empty())
    return;
  Base *p = first;
  first = first->Next;
  delete p;
}

void List::Print() const {
  cout << "Obsah seznamu: " << endl;
  if(Empty()) {
    cout << " seznam je przdn" << endl;
    return;
  }
  Base *p;
  int i;
  for(p=first, i=1; p ; p=p->Next, i++) {
    cout << i << ": \t";
    p->Print(); 	      // virtuln metoda
    cout << endl;
  }
}

int main() {
  List L;                    // vytvoen przdnho seznamu
  
  L.Insert(new Type1(123));  // konvertuje ukazatel na  Base *
  L.Insert(new Type2('b'));
  L.Insert(new Type2('c'));
  L.Insert(new Type1(4));
  L.Print();
  return 0;
}

// konec
